# Animated Brush Creator v0.1 
# Python plug-in for GIMP
# version 0.1
# 
# This is a helper script, it duplicates given layer n number of times,
# rotating each instance n degrees
# After which user must manually save the brush as .gih file

#
#2012-May
# Andrei Roslovtsev
# www.bytes-and-pixels.com
# andrei[AT]bytes-and-pixels.com

#Dev Notes [2010-11-19]
#-----------------------------------------------------------


from gimpfu import *
from math import *

def make_layers(image,drawable,frames,rotation,add_matte):
    frames = frames-1

    if image.base_type != 0:
        pdb.gimp_convert_rgb(image)

        
    src_layer = find_layer_by_name(image,'1')
    if src_layer == None:
            pdb.gimp_message('Source Layer must be named "1"')
    else:

        if add_matte:
            if image.base_type != 1:
                pdb.gimp_convert_grayscale(image)

            bg = (1.0,1.0,1.0,1.0)
            pdb.gimp_context_set_background(bg)
            matte = pdb.gimp_layer_new(image, image.width, image.height,
                                       3, 'matte', 100, 0)
            pdb.gimp_image_add_layer(image, matte, 1)
            pdb.gimp_edit_fill(matte, 1)
            src_layer = pdb.gimp_image_merge_visible_layers(image, 1)
            pdb.gimp_drawable_set_visible(src_layer, 0)
            pdb.gimp_drawable_set_name(src_layer, '1')
            
            
        for i in range(int(frames)):
            
            src_layer = find_layer_by_name(image,str(i+1))
            
            pdb.gimp_drawable_set_visible(src_layer, 0)
            
            layer_copy = pdb.gimp_layer_new_from_drawable(src_layer, image)

            if add_matte:
                matte = pdb.gimp_layer_new(image, image.width, image.height,
                                       3, str(i+2), 100, 0)            
                pdb.gimp_image_add_layer(image, matte, -1)
                pdb.gimp_image_add_layer(image, layer_copy, -1)
                pdb.gimp_edit_fill(matte, 1)
                pdb.gimp_drawable_set_visible(matte, 1)
                pdb.gimp_drawable_set_visible(layer_copy, 1)

                rotated_copy = pdb.gimp_drawable_transform_rotate_default(layer_copy, math.radians(rotation), 1,
                                                                          image.width/2, image.height/2, 1,1)           
                pdb.gimp_drawable_update(rotated_copy, 0, 0, image.width,
                                         image.height)
                pdb.gimp_image_merge_visible_layers(image, 1)
            else:
                pdb.gimp_image_add_layer(image, layer_copy, -1)
                rotated_copy = pdb.gimp_drawable_transform_rotate_default(layer_copy, math.radians(rotation), 1,
                                                                          image.width/2, image.height/2, 1,1)
                pdb.gimp_drawable_set_name(rotated_copy, i+2)
                pdb.gimp_drawable_update(rotated_copy, 0, 0, image.width,
                                         image.height)


    for l in image.layers:
        pdb.gimp_drawable_set_visible(l, 1)
                                                                          
                                                                          
                                                                    

##            pdb.gimp_drawable_set_visible(rotated_copy, 1)
            #pdb.gimp_layer_resize_to_image_size(rotated_copy)
        
#Helper functions
#Author:  Joao S. O. Bueno
#source:  http://www.gimpusers.com/forums/gimp-user/
#    11870-set-active-layer-by-referring-to-its-name

def find_layer_by_name (image, name):
    for layer in image.layers:
        if layer.name == name:
            return layer
            return None
#-----------------------------------------------------------------
register(
    "Animated-Brush-Creator",
    N_("Batch transform and duplicate layers"),
    "Batch duplicate and rotate layers",
    "Andrei Roslovtsev",
    "www.bytes-and-pixels.com",
    "2012",
    "_Animated Brush Creator",
    "RGB*, GRAY*",
    [
        (PF_IMAGE, "image",       "Input image", None),
        (PF_DRAWABLE, "drawable", "Input drawable", None),
        (PF_SPINNER, "frames", "Frames:", 72, (2, 100, 1)),
        (PF_SPINNER, "rotation", "Rotation (degrees):", -5, (-90, 90, 1)),
        (PF_TOGGLE, "add_matte",   "Add White BG:", 0)
    ],
    [],
    make_layers,
    #menu="<Image>/File/Create/Buttons",
    menu="<Image>/Filters/Bytes-and-Pixels.com",
    domain=("gimp20-python", gimp.locale_directory)
    )

main()
